﻿Type=Class
Version=4.5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Class_Globals
	Private Windows, Linux, Mac As Boolean
	Private Version As Int
	Private Name As String
	Private PB As Shell
	Private UnderscoreReplacement As Boolean
	Private fx As JFX
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

End Sub

Public Sub IsWindows As Boolean
	Return Windows	
End Sub

Public Sub IsLinux As Boolean
	Return Linux
End Sub

Public Sub IsMac As Boolean
	Return Mac
End Sub

Public Sub OSVersion As Int
	Return Version
End Sub

Public Sub OSName As String
	Return Name
End Sub

Public Sub SetReplaceUnderscores (QR As Boolean)
	UnderscoreReplacement = QR
End Sub
#End Region

'Detects the OS's name and version. You can use the detected values by calling
'OS.OSName and OS.OSVersion as a String and Int, respectively.
Public Sub DetectOperatngSystem
	Dim OS As String = GetSystemProperty("os.name","").ToLowerCase
	Dim V As Int = GetSystemProperty("os.version","")
	If OS.Contains("win") Then
		Windows = True
		If V = 10 Then
			Version = 10 
			Name = "Windows 10"
		Else If V = 8.1 Then 
			Version = 8.1
			Name = "Windows 8.1"
		Else If V = 8 Then 
			Version = 8
			Name = "Windows 8"
		Else If v = 7 Then
			Version = 7
			Name = "Windows 7"
		Else If V = 6 Then
			Version = 6
			Name = "Windows XP"
		Else If V = 5 Then
			Version = 5
			Name = "Windows Vista"
		End If
	Else If OS.Contains("lin") Then
		'So many Linux distributions that I'm just gonna set the Version and Name properties to what the OS returns.
		Linux = True
		Version = GetSystemProperty("os.version","")
		Name = GetSystemProperty("os.name","")
	Else If OS.Contains("mac") Then
		Mac = True
		If V = 10.12 Then
			Version = 10.12
			Name = "Sierra"
		Else If V = 10.11 Then
			Version = 10.11
			Name = "El Captain"
		Else If V = 10.10 Then
			Version = 10.10
			Name = "Yosemite"
		Else If V = 10.9 Then
			Version = 10.9
			Name = "Mavericks"
		Else If V = 10.8 Then
			Version = 10.8
			Name = "Mountain Lion"
		End If
	End If
End Sub

Public Sub Execute (Executable As String, Command As String)
	Dim DTools As DirectoryTools
	DTools.Initialize
	Dim Args As List
	Args.Initialize	
	If Executable.ToLowerCase.Contains("cmd") Then
		Executable = "C:\Windows\System32\cmd.exe"
		Args.Add("/c")
	End If
	Dim ResultCommand() As String = Regex.Split(" ", Command)		
	For Each C As String In ResultCommand
		If UnderscoreReplacement = True Then
			If C.Contains("""") Then
				C = C.Replace("_"," ")
			End If			
		End If
		Args.Add(C)
	Next
	Log (Args)
	PB.Initialize("Execute", Executable, Args)
	PB.Run(-1)
End Sub

Public Sub Execute2 (Command As String)
	Dim DTools As DirectoryTools
	DTools.Initialize
	Dim Args As List
	Args.Initialize	
	Dim Executable As String
	DetectOperatngSystem
	If IsWindows Then
		Executable = "C:\Windows\System32\cmd.exe"
		Args.Add("/c")
	End If
	Dim ResultCommand() As String = Regex.Split(" ", Command)		
	For Each Command As String In ResultCommand
		If UnderscoreReplacement = True Then
			If Command.Contains("""") Then
				Command = Command.Replace("_"," ")
			End If			
		End If
		If IsLinux Or IsMac Then
			Executable = Command.SubString2(0, Command.IndexOf(" "))
		End If
		Args.Add(Command)
	Next
	Log (Args)
	PB.Initialize("Execute", Executable, Args)
	PB.Run(-1)
End Sub

Private Sub Execute_ProcessCompleted (Success As Boolean, ExitCode As Int, StdOut As String, StdErr As String)
	File.WriteString(File.DirTemp, "cbl_execute.txt", StdOut)
	File.WriteString(File.DirTemp, "cbl_execute.txt", StdErr)
End Sub

Public Sub Result As String
	Dim Reader As String
	If File.Exists(File.DirTemp, "cbl_execute.txt") Then
		Reader = File.ReadString(File.DirTemp, "cbl_execute.txt")
	Else
		Reader = "Error: File Doesn't Exist"
	End If
	Return Reader
End Sub